Bug 1044536 - JON (3.2.0) -- JON treats latest plugin as an obsolete and deletes it during plugin upgrade
Summary: JON (3.2.0) -- JON treats latest plugin as an obsolete and deletes it during ...
Keywords:
Status: VERIFIED
Alias: None
Product: JBoss Data Grid 6
Classification: JBoss
Component: JON Plugin
Version: 6.2.0
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: CR1
: 6.2.0
Assignee: Tristan Tarrant
QA Contact: Martin Gencur
URL:
Whiteboard:
Depends On:
Blocks: 1017190 1012435
TreeView+ depends on / blocked
 
Reported: 2013-12-18 13:59 UTC by Tomas Sykora
Modified: 2014-01-03 11:53 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)
JON throws away the latest JDG server plugin during plugin upg process (7.12 KB, text/plain)
2013-12-18 13:59 UTC, Tomas Sykora
no flags Details

Description Tomas Sykora 2013-12-18 13:59:06 UTC
Created attachment 838372 [details]
JON throws away the latest JDG server plugin during plugin upg process

JON 3.2.GA (respin number 7 -- current latest) simply deletes latest version of JDG server plugin during the process of plugin upgrade. 


Scenarion:

JON 3.2.GA is installed with the JDG 6.1.GA plugin pack.

The latest plugin infinispan-server-rhq-plugin-6.0.0.Final-redhat-3.jar (JDG ER6) is imported and expected to upgrade 6.1.GA plugin.

JON simply throws the new plugin away:

06:12:51,668 INFO  [org.rhq.enterprise.server.core.plugin.AgentPluginScanner] (pool-7-thread-1) Deleted an obsolete agent plugin file: /home/hudson/jon-server-3.2.0.GA/modules/org/rhq/server-startup/main/deployments/rhq.ear/rhq-downloads/rhq-plugins/infinispan-server-rhq-plugin-6.0.0.Final-redhat-3.jar 


The strange behaviour is that it does not need to disable old plugin, delete it and purge it. Wait until the process of purge finish, manually import infinispan-server-rhq-plugin-6.0.0.Final-redhat-3.jar and this is not registered by agents and we are not able to monitor Infinispan subsystem inside of JDG servers.

I did one experiment and renamed the new plugin to:

jboss-datagrid-server-rhq-plugin-6.2.0.GA-redhat-3.jar in order to workaround problems with the fact that 6.0.0 string is probably treated as a lower version than 6.0.1, or 6.1 respectively.

It didn't help either.

Please, see attachment with log output snippet from JON's server.log.

Comment 2 Tomas Sykora 2013-12-18 14:07:52 UTC
Added into blockers for JDG 6.2 and JON 3.2 to let appropriate representatives know about this issue.

Please, decide whether this is real blocker in dependence on the customer use-cases and whether we need the process of plugin upgrade working.

i.e. there are some customers using JON 3.2 with JDG 6.1 plugin pack and they want to upgrade plugin to JDG 6.2 version once JDG 6.2 is out.

Thank you

Comment 3 Martin Gencur 2013-12-18 14:11:18 UTC
I think this is a blocker because different versions of plugins should be able to co-exist in the package.

Comment 4 Tomas Sykora 2013-12-19 10:24:16 UTC
Just to let everyone know about current status:

Tristan's proposed fix is working. Explicit definition of plugin version inside of xml file helped like a charm.

I verified it is working with modified plugin.

When JON obtains the new plugin, it deletes 2 old plugins -- correct.

04:58:19,914 INFO  [org.rhq.enterprise.server.core.plugin.AgentPluginScanner] (pool-7-thread-1) Deleted an obsolete agent plugin file: /home/hudson/jon-server-3.2.0.GA/modules/org/rhq/server-startup/main/deployments/rhq.ear/rhq-downloads/rhq-plugins/jboss-datagrid-rhq-plugin-6.0.1.GA-redhat-1.jar
04:58:19,914 INFO  [org.rhq.enterprise.server.core.plugin.AgentPluginScanner] (pool-7-thread-1) Deleted an obsolete agent plugin file: /home/hudson/jon-server-3.2.0.GA/modules/org/rhq/server-startup/main/deployments/rhq.ear/rhq-downloads/rhq-plugins/jboss-datagrid-server-rhq-plugin-6.1.0.GA-redhat-1.jar


Thank you Tristan for quick fix!!

Fix for this should be part of CR1.
Expecting this BZ in ON_QA state for CR1.

Comment 5 Tomas Sykora 2014-01-03 11:53:00 UTC
Brilliant!

VERIFIED with CR1.

Now, JON deletes OLD obsolete plug-ins which came from OLD plug-in pack, and imports the new plug-in.


Note You need to log in before you can comment on or make changes to this bug.